<!-- 分包管理项目选择列表 -->
<script setup lang="ts" name="selectProjectNo">
import { ref } from 'vue'
import type { Ref } from 'vue'
import { ElMessage } from 'element-plus'
import type { IListQueryProject, IProjectList } from '../../subpackage-interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { listPageOutsourceProject } from '@/api/business/subpackage/apply'

const props = defineProps({
  visible: {
    type: Boolean,
    default: false,
  },
  formId: {
    type: String,
    default: '',
  },
})

const emits = defineEmits(['changeVisible', 'clickConfirmProject'])

// 查询条件
const listQuery: Ref<IListQueryProject> = ref({
  formId: props.formId!,
  projectName: '',
  projectNo: '',
  offset: 1,
  limit: 20,
})
// 表头
const columns = ref<TableColumn[]>([
  { text: '项目编号', value: 'id', width: '160', align: 'center' },
  { text: '项目名称', value: 'projectName', width: '120', align: 'center' },
  { text: '申请时间', value: 'applicantTime', align: 'center' },
  // { text: '备注', value: 'applyRemark', align: 'center' },
])
// 表格数据
const list = ref<IProjectList[]>([])
// 总数
const total = ref(0)
// 表格加载状态
const loadingTable = ref(false)
// 选中的内容
const checkoutList = ref<string[]>([])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  // listQuery.value.customerId = props.customerId
  // listQuery.value.id = props.orderId
  listPageOutsourceProject(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: any) => {
    return {
      ...item,
      isEdit: false,
    }
  })
}
// 点击搜索
const searchList = () => {
  fetchData(true)
}
// 点击重置
const clearList = () => {
  listQuery.value = {
    formId: props.formId!,
    projectName: '',
    projectNo: '',
    offset: 1,
    limit: 20,
  }
  fetchData(true)
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 点击取消
const cancle = () => {
  emits('changeVisible', false)
}

// 点击确定
const clickConfirmProject = () => {
  if (!checkoutList.value.length) {
    ElMessage({
      message: '请选中',
      type: 'warning',
    })
  }
  // 将选择好的样品传给父组件
  emits('clickConfirmProject', checkoutList.value)
  cancle()
}

watch(() => props.visible, (newValue) => {
  if (newValue) {
    fetchData(true)
  }
})
</script>

<template>
  <div class="select-kehu-dialog">
    <el-dialog :modelValue="visible" title="选择项目" width="65%" @close="cancle">
      <search-area :need-clear="true" style="padding-left: 0;padding-right: 0;" @search="searchList" @clear="clearList">
        <search-item>
          <el-input v-model.trim="listQuery.projectNo" placeholder="项目编号" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.projectName" placeholder="项目名称" class="short-input" clearable />
        </search-item>
      </search-area>
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
        :height="260" :is-multi="false" @change="changePage" @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset as number - 1) * (listQuery.limit as number) + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
      <template #footer>
        <el-button type="primary" @click="clickConfirmProject">
          确定
        </el-button>
        <el-button @click="cancle">
          取消
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
